#include <string>
#include <iostream>
#include <mysql.h>
#include <thread>
#include <mutex>


int main()
{
  const std::string host="host";
  const std::string db="db_name";
  const std::string user="user";
  const std::string pass="password";
  const unsigned int port=3306;
  const unsigned int threads_count=20;

  std::mutex _cout_mutex;

  mysql_library_init(0, nullptr, nullptr);


  auto connect=[&]
    {
      MYSQL *conn = mysql_init(nullptr);
      if (conn == nullptr)
	{
	  std::lock_guard<std::mutex> lock(_cout_mutex);
	  std::cout<<"Can not creare connection"<<std::endl;
	  return;
	}
      
      if(nullptr!=mysql_real_connect (conn,
				      host.c_str(),
				      user.c_str(),
				      pass.c_str(),
				      db.c_str(),
				      port,
				      nullptr,
				      0))
	{
	  std::lock_guard<std::mutex> lock(_cout_mutex);
	  std::cout<<"Connected"<<std::endl;
	} 
      else
	{
	  std::lock_guard<std::mutex> lock(_cout_mutex);
	  std::cout<<"Connection error="<<mysql_error(conn)<<std::endl;
	}
      
    };

  for (unsigned i=0; i<=threads_count;i++)
    {
      std::thread t(connect);
      t.detach();
    }

  while(true);

  return 0;
}

